{{- if or (eq .Values.global.env "production") (eq .Values.global.env "staging")}}
---
apiVersion: batch/v1
kind: Job
metadata:
  name: {{ .Chart.Name }}-postgresql-create-db
  annotations:
    "helm.sh/hook": pre-install
    "helm.sh/hook-weight": "1"
    "werf/watch-logs": "true"
spec:
  activeDeadlineSeconds: 60
  backoffLimit: 0
  template:
    metadata:
      name: {{ .Chart.Name }}-postgresql-create-db
    spec:
      initContainers:
      - name: wait-postgresql
        image: alpine:3.6
        command: ['/bin/sh', '-c', 'while ! getent ahostsv4 {{ pluck .Values.global.env .Values.db.host | first | default .Values.db.host._default }}; do sleep 1; done']
      containers:
        - name: job
          image: postgres:10.5
          env:
          - name: PGDATABASE
            value: postgres
          - name: PGUSER
            value: admin
          - name: PGPASSWORD
            value: {{ .Values.global.postgresql_admin_password }}
          - name: PGHOST
            value: {{ .Chart.Name}}-postgresql
          command:
          - bash
          - -l
          - -c
          - >
{{- $database := pluck .Values.global.env .Values.db.database | first | default .Values.db.database._default }}
{{- $user := pluck .Values.global.env .Values.db.username | first | default .Values.db.username._default }}
{{- $password := pluck .Values.global.env .Values.db.password | first | default .Values.db.password._default }}
            until
            psql -tc "SELECT 1 FROM pg_database WHERE datname = '{{ $database }}'" | grep -q 1 || psql -c 'CREATE DATABASE "{{ $database }}";';
            do echo "Failed to create database {{ $database }}. Retrying..."; sleep 1 ;
            done ;
            until
            psql -tc "SELECT 1 FROM pg_user WHERE usename = '{{ $user }}'" | grep -q 1 || psql -c "CREATE USER \"{{ $user }}\" WITH ENCRYPTED PASSWORD '{{ $password }}';";
            do echo "Failed to create user {{ $user }}. Retrying..."; sleep 1 ;
            done ;
            until
            psql -c 'GRANT ALL PRIVILEGES ON DATABASE "{{ $database }}" TO "{{ $user }}";';
            do echo "Failed to grant permissions. Retrying..."; sleep 1 ;
            done ;
      restartPolicy: Never
{{- end }}